function [XYZ,Y]=dac2xyz(n,primarios,ruido,par,tipoajuste)

%Calcula los valores triestímulo que se generan con los niveles digitales
%indicados, a partir de los datos del perfil ICC del monitor.
%
%USO: [XYZ,Y]=dac2xyz(n,primarios,ruido,par,tipoajuste)
%
%n: matriz Nx3 de niveles digitales
%primarios, ruido, par, tipoajuste son los valores obtenidos con
%calculaperfil y guardados en el archivo *ICC.mat del monitor.
%
%Esta función sólo trabaja con la caracterización del centro. 


fun{1}=inline('abs(par(1))*n.^abs(par(2))./(n.^abs(par(3))+abs(par(4)))','par','n');
fun{2}=inline('abs(par(1))*n.^abs(par(2))','par','n');
fun{3}=inline('1-exp(-(n/abs(par(1))).^abs(par(2)))','par','n');
fun{4}=inline('par(1)./(1+exp(par(2)*n))','par','n');


if numel(tipoajuste)==1
    tipoajuste=repmat(tipoajuste,1,3);
end
for i=1:3
  Y(:,i)=fun{tipoajuste(i)}(par{i},n(:,i));
end
Y(Y<0)=0;
XYZ=(primarios{1}'*Y')'+repmat(ruido{1},size(Y,1),1);
