function pausacolor

global temporizador datos

temporizador = createErgoTimer;
start(temporizador)
%Starting Ergonomic Break Timer.  For the next 8 hours you will be notified to take a 30 second break every 10 minutes.
%Every 10 minutes, you will be reminded to take a 30 second break.

%Take a break.
%You can leave the timer running for 8 hours or stop it manually. Recall that you included the task of deleting the timer from memory in the StopFcn callback.


function t = createErgoTimer
secondsBreak = 2;
secondsBreakInterval = 5;
secondsPerHour = 60^2;
secondsWorkTime = 8*secondsPerHour;

t = timer;
t.UserData = secondsBreak;
%t.StartFcn = @ergoTimerStart;
t.TimerFcn = @takeBreak;
t.StopFcn = @ergoTimerCleanup;
t.Period = secondsBreakInterval;
t.StartDelay = t.Period;
t.TasksToExecute = ceil(secondsWorkTime/t.Period);
t.ExecutionMode = 'fixedSpacing';


function takeBreak(mTimer,~)
%disp('Take a 30 second break.')
global datos
%set(gcf,'WindowKeyPressFcn',[])

figure(gcf);
%datos=guidata(gcf)
datos.pal0=datos.pal;
datos.pal(2:3,:)=repmat(datos.pal(1,:),2,1);
imshow(datos.im,datos.pal,'initialmagnification','fit');
pause(mTimer.UserData);
datos.pal=datos.pal0;
imshow(datos.im,datos.pal,'initialmagnification','fit');
%set(gcf,'WindowKeyPressFcn',@teclasiguala)



%Add a local function to handle the tasks associated with stopping the timer.

function ergoTimerCleanup(mTimer,~)
disp('Stopping Ergonomic Break Timer.');
delete(mTimer)

%Deleting the timer object removes it from memory.

%From the command line, call the createErgoTimer function to create and start a timer.

