function [n,XYZpos,sat,fuera]=xyz2dac(XYZ,primarios,ruido,par,tipoajuste,res)

%Calcula los valores triestímulo que se generan con los niveles digitales
%indicados
%
%USO: [n,XYZpos,sat,fuera]=xyz2dac(XYZ,primarios,ruido,par,tipoajuste,res)
%
%XYZ: matriz Nx3 de valores triestímulo
%primarios, ruido, par, tipoajuste son los valores obtenidos con
%calculaperfil y guardados en el archivo *ICC.mat del monitor.
%n: niveles digitales
%XYZpos: colores que se generarían realmente
%sat: vector de N elementos, que valen 1 si la luminancia de algún fósforo
%para generar el color correspondiente supera el máximo del monitor, y cero
%en caso contrario.
%fuera: matriz Nx3 que indica si de algún primario haría falta una
%luminancia negativa (color fuera del triángulo de primarios).
%
%Esta función sólo trabaja con la caracterización del centro. 


sat=zeros(size(XYZ,1),1);
fuera=zeros(size(XYZ));
Y=(inv(primarios{1}')*(XYZ-repmat(ruido{1},size(XYZ,1),1))')';
fuera(Y<0)=-1;
Y(Y<0)=0;
if numel(tipoajuste)==1
    tipoajuste=repmat(tipoajuste,1,3);
end

for i=1:3
  if tipoajuste(i)==2
     n(:,i)=(Y(:,i)/par{i}(1)).^(1/par{i}(2));
  elseif tipoajuste(i)==1
    fun=inline('sum((Y-abs(par(1))*abs(n).^abs(par(2))./(abs(n).^abs(par(3))+abs(par(4)))).^2)','n','par','Y');
        for j=1:size(Y,1)
            y=Y(j,i);
            p=par{i};
            nm(j,i)=abs(fminsearch(@(n) fun(n,p,y),0.5));
        end
        sat(nm(:,i)>1)=1;
        nm(nm(:,i)>1,i)=1;
        n(:,i)=nm(:,i);
  elseif tipoajuste(i)==3
    fun=inline('par(1)*(-log(1-Y))^(1/par(2))','par','Y');  
    n(:,i)=fun(par{i},Y(:,i));
    
  elseif tipoajuste(i)==4
    fun=inline('(log((par(1)-Y)/Y))/par(2)','par','Y');
    n(:,i)=fun(par{i},Y(:,i));
  end
  
end
n(n<0)=0;
n=round(n*2^res)/(2^res);
XYZpos=dac2xyz(n,primarios,ruido,par,tipoajuste);
